/////////////////////////////////////////////////////////////
///  Digilog.mihanblog.com        ///////////////////////////
/// 					          ///////////////////////////
///	 MFRC522 RFID module          ///////////////////////////
///  DEVELOPED BY MiladShiri      ///////////////////////////
///	 Ordibehesht 1393             ///////////////////////////
///  ver 1.0 					  ///////////////////////////
/////////////////////////////////////////////////////////////


#include <lpc17xx.h>
#include "MFRC522.h"
#include "lpc17xx_gpio.h"
#include "lpc17xx_pinsel.h"
#include "serial.h"


char get;
char getdata[16];
int l,ii;
char senddata[]={52,49,46,46,70,24,0,0,57,41,56,45,66,65,74,66};
char reset[]={0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};



byte keyA[6] = {0xFf, 0xFf, 0xFF, 0xFF, 0xFF, 0xFF, };
byte keyB[6] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, };


void delay(int d){
  int i;
for (i=0;i<d*10000;i++);
}


void SPI_mfrc_Init(void)
{
	PINSEL_CFG_Type PinCfg;
    SSP_CFG_Type SSP_ConfigStruct;
	/*
	 * Initialize SPI pin connect
	 * P0.15 - SCK	13
	 * P0.16 - SSEL - used as GPIO	14
	 * P0.17 - MISO					  15
	 * P0.18 - MOSI						16
	 */
	PinCfg.Funcnum = 2;
	PinCfg.OpenDrain = 0;
	PinCfg.Pinmode = 0;
	PinCfg.Portnum = 0;
	PinCfg.Pinnum = 15;
	PINSEL_ConfigPin(&PinCfg);
	PinCfg.Pinnum = 17;
	PINSEL_ConfigPin(&PinCfg);
	PinCfg.Pinnum = 18;
	PINSEL_ConfigPin(&PinCfg);
	PinCfg.Pinnum = 16;
	PinCfg.Funcnum = 0;
	PINSEL_ConfigPin(&PinCfg);

    /* P0.16 CS is output */
    GPIO_SetDir(CS_PORT_NUM, (1<<CS_PIN_NUM), 1);
	GPIO_SetValue(CS_PORT_NUM, (1<<CS_PIN_NUM));  

	/* initialize SSP configuration structure to default */
	SSP_ConfigStructInit(&SSP_ConfigStruct);
	/* Initialize SSP peripheral with parameter given in structure above */
	SSP_Init(LPC_SSP0, &SSP_ConfigStruct);
	/* Enable SSP peripheral */
	SSP_Cmd(LPC_SSP0, ENABLE);
}




   void main(){

	unsigned char i,j = 0;
	SystemInit();
	SER_init (0);

	LPC_SC->PCONP |= (1<<8);
	LPC_PINCON->PINSEL0 |= (0XC0000000); // p0.15 SCK
	LPC_PINCON->PINSEL1 |= (0XC000003f); // p0.17 Miso  p0.18 mosi p0.16 ssel
	LPC_SPI->SPCCR = 024;
	LPC_SPI->SPCR=0X824;
	// MASATER      8BIT DATA
	// 18 MHZ
	
	SER_putString(0,"Hello World");
	while(1){
		LPC_SPI->SPDR=i;		// char to send
		while (!(LPC_SPI->SPSR & 0x80));		// wait for send
		j = LPC_SPI->SPDR;
		SER_putChar(0,j);
		i++;
		delay (1000);
	  }
	 }



